/*
 * Copyright (c) Chris Knepper (cknepper@starpt.com).  All rights reserved.
 * Modified by Martin Kuzela 1998 (kuzela@adela.sk)
 */

package ows;

public class Base64
{

public static String decode(String encodedString)
{
  char[] newCharArray = new char[256];
  int newCharIndex = 0;
  char[] charArray = encodedString.toCharArray();

  for (int i = 0; i < charArray.length; )
  {
    char ithChar = charArray[i];
    char iPlusOneChar = charArray[i+1];
    if ( ithChar == '=' || iPlusOneChar == '=' )
      break;
    char curChar = base64Table(ithChar);
    curChar <<= 2;
    curChar &= 127;
    char nextChar = base64Table(iPlusOneChar);
    nextChar >>>= 4;
    newCharArray[newCharIndex++] = (char)(curChar | nextChar);

    ithChar = iPlusOneChar;
    iPlusOneChar = charArray[i+2];
    if ( iPlusOneChar == '=' )
      break;
    curChar = base64Table(ithChar);
    curChar <<= 4;
    curChar &= 127;
    nextChar = base64Table(iPlusOneChar);
    nextChar >>>= 2;
    newCharArray[newCharIndex++] = (char)(curChar | nextChar);

    ithChar = iPlusOneChar;
    iPlusOneChar = charArray[i+3];
    if ( iPlusOneChar == '=' )
      break;
    curChar = base64Table(ithChar);
    curChar <<= 6;
    curChar &= 127;
    nextChar = base64Table(iPlusOneChar);
    newCharArray[newCharIndex++] = (char)(curChar | nextChar);
    i += 4;
  }
  return new String(newCharArray, 0, newCharIndex);
}

private static char base64Table(char base64char)
{
  if (( base64char >= 'A' ) && ( base64char <= 'Z' ))
    return (char)(base64char - 'A');
  if (( base64char >= 'a' ) && ( base64char <= 'z' ))
    return (char)(base64char - 'a' + 26);
  if (( base64char >= '0' ) && ( base64char <= '9' ))
    return (char)(base64char - '0' + 52);
  if ( base64char == '+' )
    return 62;
  if ( base64char == '/' )
    return 63;
  return 0;
}

}
